commit 952c09791d8a4c6e4ff8067fad45d6e1e8a0ce56
Author: Sofia Papagiannaki <papagian@gmail.com>
Date:   Mon Nov 5 15:08:19 2012 +0200

    Set additional default resource information (description, unit)

diff --git a/snf-astakos-app/README b/snf-astakos-app/README
index 842e632..61651a8 100644
--- a/snf-astakos-app/README
+++ b/snf-astakos-app/README
@@ -85,21 +85,41 @@ ASTAKOS_INVITATION_EMAIL_SUBJECT            'Invitation to %s alpha2 testing' %
 ASTAKOS_GREETING_EMAIL_SUBJECT              'Welcome to %s alpha2 testing' % SITENAME                                       Welcome email subject
 ASTAKOS_FEEDBACK_EMAIL_SUBJECT              'Feedback from %s alpha2 testing' % SITENAME                                    Feedback email subject
 ASTAKOS_VERIFICATION_EMAIL_SUBJECT          '%s alpha2 testing account activation is needed' % SITENAME                     Account activation email subject
-ASTAKOS_ACCOUNT_CREATION_SUBJECT = getattr(settings, 'ASTAKOS_ACCOUNT_CREATION_SUBJECT',
-        '%s alpha2 testing account created (%%(user)s)' % SITENAME)
-ASTAKOS_GROUP_CREATION_SUBJECT = getattr(settings, 'ASTAKOS_',
-        '%s alpha2 testing group created (%%(group)s)' % SITENAME)
+ASTAKOS_ACCOUNT_CREATION_SUBJECT            '%s alpha2 testing account created (%%(user)s)' % SITENAME                      Account creation email subject
+ASTAKOS_GROUP_CREATION_SUBJECT              '%s alpha2 testing group created (%%(group)s)' % SITENAME                       Group creation email subject
 ASTAKOS_HELPDESK_NOTIFICATION_EMAIL_SUBJECT '%s alpha2 testing account activated (%%(user)s)' % SITENAME                    Account activation helpdesk notification email subject
 ASTAKOS_EMAIL_CHANGE_EMAIL_SUBJECT          'Email change on %s alpha2 testing' % SITENAME                                  Email change subject               
 ASTAKOS_PASSWORD_RESET_EMAIL_SUBJECT        'Password reset on %s alpha2 testing' % SITENAME                                Password change email subject
 
 ASTAKOS_QUOTA_HOLDER_URL                    ''                                                                              The quota holder URI
-                                                                                                                    e.g. ``http://localhost:8080/api/quotaholder/v``
-ASTAKOS_SERVICES                            {'cyclades': {'url':'https://node1.example.com/ui/', 'quota': {'vm': 2}},       Cloud service default url and quota      
-                                            'pithos+':  {'url':'https://node2.example.com/ui/', 'quota': {                  
-                                            'diskspace': 50 * 1024 * 1024 * 1024}}})                                        
+                                                                                                                            e.g. ``http://localhost:8080/api/quotaholder/v``
+ASTAKOS_SERVICES                            {'cyclades': {'resources': [{'desc': 'Number of virtual machines',              Default cloud service information
+                                            'group': 'storage',
+                                            'name': 'vm',
+                                            'uplimit': 2},
+                                            {'desc': 'Virtual machine disk size',
+                                            'group': 'storage',
+                                            'name': 'disksize',
+                                            'unit': 'GB',
+                                            'uplimit': 5},
+                                            {'desc': 'Number of virtual machine processors',
+                                            'group': 'storage',
+                                            'name': 'cpu',
+                                            'uplimit': 1},
+                                            {'desc': 'Virtual machines',
+                                            'group': 'storage',
+                                            'name': 'ram',
+                                            'unit': 'MB',
+                                            'uplimit': 1024}],
+                                            'url': 'https://node1.example.com/ui/'},
+                                            'pithos+': {'resources': [{'desc': 'Pithos account diskspace',
+                                            'group': 'compute',
+                                            'name': 'diskspace',
+                                            'unit': 'bytes',
+                                            'uplimit': 5368709120}],
+                                            'url': 'https://node2.example.com/ui/'}}                                                                               
 ASTAKOS_AQUARIUM_URL                        ''                                                                              The billing (aquarium) URI
-                                                                                                                    e.g. ``http://localhost:8888/user``
+                                                                                                                            e.g. ``http://localhost:8888/user``
 ASTAKOS_PAGINATE_BY                         10                                                                              Number of object to be displayed per page
 
 ASTAKOS_NEWPASSWD_INVALIDATE_TOKEN          True                                                                            Enforce token renewal on password change/reset. If set to False, user can optionally decide